.DATA
ALIGN 16
;
; ici, ce sont les tmoins concernant les informations du microprocesseur
;
_Temoins_Aptitudes_Du_MicroProcesseur_	DWORD ?
; bit 0 = Cpuid support ? 1=oui, 0=non
; bit 1 = Fpu support ? 1=oui, 0=non
; bit 2 = Tsc support ? 1=oui, 0=non
; bit 3 = Cx8 support ? 1=oui, 0=non
; bit 4 = cMov support ? 1=oui, 0=non
; bit 5 = Clfsh support ? 1=oui, 0=non
; bit 6 = Mmx support ? 1=oui, 0=non
; bit 7 = Fxsr support ? 1=oui, 0=non
; bit 8 = Sse support ? 1=oui, 0=non
; bit 9 = Sse2 support ? 1=oui, 0=non
; bit 10 = Htt support ? 1=oui, 0=non
; bit 11 = Sse3 support ? 1=oui, 0=non
; bit 12 =

;_Temoin_Type_Du_MicroProcesseur_		DWORD ?
;
;
;
;
;


.CODE
ALIGN 16
;
; obtenir des informations sur le microprocesseur qui utilise le programme
;
; Syntaxe :
; call DefinirAptitudesDuProcesseur
;
; Retourne :
; eax et la variable _Temoins_Aptitudes_Du_MicroProcesseur_ sont dfinis avec les bits positionns
;
DefinirAptitudesDuProcesseur PROC
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push esi										;; empiler esi

		xor esi,esi									;; mettre esi (le registre qui stockera les bits)  0
; l'instruction CPUID est supporte, seulement s'il est possible de positionner/enlever le flag ID (EFLAGS bit 21).
		pushfd										;; ) copier les flags+flags etendus dans eax et edx
		pop eax										;; )
		mov edx,eax									;; )
		btc eax,21									;; inverser le flag ID (bit 21)
		push eax										;; ) et recopier le rsultat dans les flags
		popfd										;; )
		pushfd										;;	) puis on recopie  nouveau les flags dans eax
		pop eax										;;	)
		cmp eax,edx									;; comparer le rsultat  notre prcdente sauvegarde
		je PasSupportCpuid								;; si c'est semblable, c'est que notre modif n'a eu aucun effet, alors aller PasSupportCpuid
		bts esi,0										;; positionner le bit correspondant dans esi

; ici, l'instruction cpuid est supporte, on va donc s'en servir pour connaitre les aptitudes du processeur
;		mov eax,0										;; ici, on dtermine le type d'infos que l'on veut rcuprer
;		cpuid										;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
;													;; (eax contient le nombre d'entres cpuid maximales)

; ici, on passe aux informations suivantes
		mov eax,1										;; ici, on dtermine les infos les plus importantes (du moins pour la programmation)
		cpuid										;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
													;; (eax contient le type, le model,la famille,...)
													;; (edx contient les caractristiques disponibles)
; les instructions fpu sont disponibles ?
		bt edx,0										;; tester le bit 0
		jnc PasSupportFpu								;; si le flag carry n'est pas positionn, aller PasSupportFpu
		bts esi,1										;; positionner le bit correspondant dans esi
PasSupportFpu:
; l'instruction rdtsc est disponible ?
		bt edx,4										;; tester le bit 4
		jnc PasSupportRdtsc								;; si le flag carry n'est pas positionn, aller PasSupportRdtsc
		bts esi,2										;; positionner le bit correspondant dans esi
PasSupportRdtsc:
; l'instruction CmpXchg8b est disponible ?
		bt edx,8										;; tester le bit 8
		jnc PasSupportCmpXchg8b							;; si le flag carry n'est pas positionn, aller PasSupportCmpXchg8b
		bts esi,3										;; positionner le bit correspondant dans esi
PasSupportCmpXchg8b:
; les instructions cmov sont disponibles ?
		bt edx,15										;; tester le bit 15
		jnc PasSupportCmov								;; si le flag carry n'est pas positionn, aller PasSupportCmov
		bts esi,4										;; positionner le bit correspondant dans esi
PasSupportCmov:
; les instructions clfsh sont disponibles ?
		bt edx,19										;; tester le bit 19
		jnc PasSupportClfsh								;; si le flag carry n'est pas positionn, aller PasSupportClfsh
		bts esi,5										;; positionner le bit correspondant dans esi
PasSupportClfsh:
; les instructions mmx sont disponibles ?
		bt edx,23										;; tester le bit 23
		jnc PasSupportMmx								;; si le flag carry n'est pas positionn, aller PasSupportMmx
		bts esi,6										;; positionner le bit correspondant dans esi
PasSupportMmx:
; les instructions fxsr sont disponibles ?
		bt edx,24										;; tester le bit 24
		jnc PasSupportFxsr								;; si le flag carry n'est pas positionn, aller PasSupportFxsr
		bts esi,7										;; positionner le bit correspondant dans esi
PasSupportFxsr:
; les instructions sse sont disponibles ?
		bt edx,25										;; tester le bit 25
		jnc PasSupportSse								;; si le flag carry n'est pas positionn, aller PasSupportSse
		bts esi,8										;; positionner le bit correspondant dans esi
PasSupportSse:
; les instructions sse2 sont disponibles ?
		bt edx,26										;; tester le bit 26
		jnc PasSupportSse2								;; si le flag carry n'est pas positionn, aller PasSupportSse2
		bts esi,9										;; positionner le bit correspondant dans esi
PasSupportSse2:
; les instructions htt sont disponibles ?
		bt edx,28										;; tester le bit 28
		jnc PasSupportHtt								;; si le flag carry n'est pas positionn, aller PasSupportHtt
		bts esi,10									;; positionner le bit correspondant dans esi
PasSupportHtt:
; les instructions sse3 sont disponibles ?
		bt ecx,0										;; tester le bit 0
		jnc PasSupportSse3								;; si le flag carry n'est pas positionn, aller PasSupportSse3
		bts esi,11									;; positionner le bit correspondant dans esi
PasSupportSse3:
;; les instructions Xxx sont disponibles ?
;		bt edx,Xxx									;; tester le bit 
;		jnc PasSupportXxx								;; si le flag carry n'est pas positionn, aller
;		bts esi,x										;; positionner le bit correspondant dans esi
;PasSupportXxx:

; ici, on passe aux informations suivantes
;		mov eax,2										;; ici, on dtermine les infos concernant le cache
;		cpuid										;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
PasSupportCpuid:
		mov _Temoins_Aptitudes_Du_MicroProcesseur_,esi		;; sauvegarder les tmoins dans notre variable
		mov eax,esi									;; et les recopier dans eax

		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
	ret												;; retourner, sortir de la procdure
DefinirAptitudesDuProcesseur ENDP


ALIGN 16
;
; positionner une fentre outils  son emplacement logique
;
; Syntaxe :
; mov esi,{pointeur de la fentre}
; mov edi,{OFFSET (adresse) de la structure RECT utilise}
; call PositionnerFenetreOutil
;
; Retourne :
; eax = 0 si erreur
;
; Syntaxe : PositionnerFenetreOutil
;
PositionnerFenetreOutil PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

; positionner la fentre sur la droite de notre cran (en la centrant en hauteur)
		invoke GetWindowRect,esi,edi						;; obtenir les coordonnes de la boite de dialogue
		mov eax,(RECT PTR [edi]).left						;; ) calculer la largeur et la placer dans (RECT PTR [edi]).right
		sub (RECT PTR [edi]).right,eax					;; )
		mov eax,(RECT PTR [edi]).top						;;	) calculer la hauteur et la placer dans (RECT PTR [edi]).bottom
		sub (RECT PTR [edi]).bottom,eax					;;	)
		invoke GetSystemMetrics,SM_CXSCREEN				;; obtenir la taille x de l'ecran os (en pixels)
		sub eax,(RECT PTR [edi]).right					;; soustraire la largeur de notre ecran final
		mov (RECT PTR [edi]).left,eax						;; placer la nouvelle position x
		add (RECT PTR [edi]).right,eax					;; et ajouter la position x  la taille x
		invoke GetSystemMetrics,SM_CYSCREEN				;; obtenir la taille y de l'ecran os (en pixels)
		sub eax,(RECT PTR [edi]).bottom					;; soustraire la largeur de notre ecran final
		sar eax,1										;; pour centrer verticalement
		mov (RECT PTR [edi]).top,eax						;; placer la nouvelle position Y
		add (RECT PTR [edi]).bottom,eax					;; et ajouter la position y  la taille y
		invoke GetSystemMetrics,SM_CXVSCROLL				;; ) enlever la largeur d'une barre de scrolling verticale
		sub (RECT PTR [edi]).left,eax						;; )
		sub (RECT PTR [edi]).right,eax					;; )
		invoke GetSystemMetrics,SM_CXBORDER				;; ) (ici, avec les bordures)
		add eax,eax									;; plus rapide que :
;		shl eax,1										;; 
		sub (RECT PTR [edi]).left,eax						;; )
		sub (RECT PTR [edi]).right,eax					;; )
		invoke SetWindowPos,esi,NULL,(RECT PTR [edi]).left,(RECT PTR [edi]).top,NULL,NULL,SWP_NOSIZE or SWP_NOZORDER

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner, sortir de la procdure
PositionnerFenetreOutil ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de traitement des blocs mmoire
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;.DATA
;ALIGN 16
;


.CODE
ALIGN 16
;
; allouer un bloc mmoire  un pointeur (ce bloc est align sur 16 octets)
; note : la structure _Informations_Memoire_ doit, videment, avoir t au pralable cre et dfinie
; enfin, comme ici on alloue un bloc mmoire, il faudra le librer en fin de programme avec LibererBlocMemoire
;
; Syntaxe :
; mov eax,{taille du bloc mmoire que l'on va crer (en octets)}
; mov esi,{adresse (offset) d'une structure _Informations_Memoire_}
; mov edi,{adresse (offset) d'une structure _Bloc_Memoire_}
; call AllouerBlocMemoire
;
; Retourne :
; eax = adresse du bloc mmoire align
; et les variables de la structure _Bloc_Memoire_ sont dfinies
;
AllouerBlocMemoire PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		mov (_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,eax		;; placer eax dans x._Taille_Du_Bloc_
		add eax,000000010h								;; ajouter 16  la taille (pour aligner le bloc mmoire sur 16 octets)
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax		;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_,eax		;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h								;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h								;; )
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_,eax		;; sauvegarder eax dans x._Pointeur_

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
AllouerBlocMemoire ENDP


ALIGN 16
;
; copier un bloc memoire vers un autre bloc memoire
; note : il faut s'assurer que les blocs mmoire ne se chevauchent pas, sinon il faut utiliser BougerBlocMemoire...
;
; Syntaxe :
; mov eax,{taille  copier en octets}
; mov esi,{adresse du bloc source}
; mov edi,{adresse du bloc de destination}
; call CopierBlocMemoire
;
; Retourne :
; rien
;
CopierBlocMemoire PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

; ici on traite les owords
		mov ecx,eax									;; copier eax dans ecx
		and ecx,11111111111111111111111111110000b			;; ne conserver que les bits owords en ecx
		jz Label1										;; si ecx est gal  0, aller Label1
		add esi,ecx									;; on ajoute ecx  esi
		add edi,ecx									;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx										;; inverser ecx
		nop											;; ) alignement ncessaire pour un meilleur rendement
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
;		nop											;; )
Label0:	mov edx,DWORD PTR[esi+ecx]						;; placer le dword en esi+ecx dans ebx
		mov DWORD PTR[edi+ecx],edx						;; placer le dword en edi+ecx
		mov edx,DWORD PTR[esi+ecx+4]						;; placer le dword en esi+ecx+4 dans edx
		mov DWORD PTR[edi+ecx+4],edx						;; placer le dword en edi+ecx+4
		mov edx,DWORD PTR[esi+ecx+8]						;; placer le dword en esi+ecx+8 dans ebx
		mov DWORD PTR[edi+ecx+8],edx						;; placer le dword en edi+ecx+8
		mov edx,DWORD PTR[esi+ecx+12]						;; placer le dword en esi+ecx+12 dans edx
		mov DWORD PTR[edi+ecx+12],edx						;; placer le dword en edi+ecx+12
		add ecx,DWORD*4								;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label0									;; tant que ecx est diffrent de 0, aller Label0
; ici on traite les dwords
Label1:	mov ecx,eax									;; copier eax dans ecx
		and ecx,00000000000000000000000000001100b			;; ne conserver que les bits dwords en ecx
		jz Label3										;; si ecx est gal  0, aller Label3
		add esi,ecx									;; on ajoute ecx  esi
		add edi,ecx									;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx										;; inverser ecx
Label2:	mov edx,DWORD PTR [esi+ecx]						;; placer le dword en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx						;; et le recopier en edi+ecx
		add ecx,DWORD									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label2									;; tant que ecx est sign, aller Label2
; ici on traite les octets
Label3:	mov ecx,eax									;; copier eax dans ecx
		and ecx,00000000000000000000000000000011b			;; ne conserver que les bits octets en ecx
		jz Label5										;; si ecx est gal  0, aller Label5
		add esi,ecx									;; on ajoute ecx  esi
		add edi,ecx									;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx										;; inverser ecx
Label4:	mov dl,BYTE PTR [esi+ecx]						;; placer l'octet en esi+edx dans dl
		mov BYTE PTR [edi+ecx],dl						;; et le recopier en edi+ecx
		inc ecx										;; on ajoute 1  ecx (notre pas de boucle)
		jnz Label4									;; tant que ecx est diffrent de 0, aller Label4
Label5:	sub esi,eax									;; soustraire la taille  esi (pour retrouver l'adresse originelle)
		sub edi,eax									;; soustraire la taille  edi (pour retrouver l'adresse originelle)

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
CopierBlocMemoire ENDP


ALIGN 16
;
; crer l'instance mmoire (ce qui doit tre fait, une fois, avant de pouvoir allouer des blocs mmoires)
; note : normalement (sauf cas exceptionnels) une seule instance suffit pour l'ensemble de votre programme
; enfin, il ne faudra pas oublier de librer l'instance en fin de programme avec SupprimerInstanceMemoire
;
; Syntaxe :
; mov esi,{adresse (offset) d'une structure _Informations_Memoire_}
; call CreerInstanceMemoire
;
; Retourne :
; eax = l'adresse de l'instance
; et les variables de la structure _Informations_Memoire_ sont dfinies
;
CreerInstanceMemoire PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapCreate,HEAP_NO_SERIALIZE,(_Informations_Memoire_ PTR [esi])._Taille_Initiale_,(_Informations_Memoire_ PTR [esi])._Taille_Maximale_		;; cr une instance mmoire, et defini des valeurs mmoire
		mov (_Informations_Memoire_ PTR [esi])._Instance_,eax		;; sauvegarde du pointeur de l'instance

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
CreerInstanceMemoire ENDP


ALIGN 16
;
; librer un bloc mmoire
; note : si il n'y a pas d'autres bloc mmoire, ne pas oublier de librer l'instance mmoire en fin de programme
;
; Syntaxe :
; mov esi,{adresse (offset) d'une structure _Informations_Memoire_}
; mov edi,{adresse (offset) d'une structure _Bloc_Memoire_}
; call SupprimerBlocMemoire
;
; Retourne :
; rien
;
SupprimerBlocMemoire PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapFree,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE,(_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_		;; librer le bloc mmoire correspondant au pointeur

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
SupprimerBlocMemoire ENDP


ALIGN 16
;
; supprimer l'instance mmoire (ce qui doit tre fait avant de sortir de l'application, si une instance  t cre)
;
; Syntaxe :
; mov esi,{adresse (offset) d'une structure _Informations_Memoire_}
; call SupprimerInstanceMemoire
;
; Retourne :
; rien
;
SupprimerInstanceMemoire PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapDestroy,(_Informations_Memoire_ PTR [esi])._Instance_		;; librer l'instance mmoire

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
SupprimerInstanceMemoire ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de traitement de chaines de caractres graphiques
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;.DATA
;ALIGN 16
;_TCA_Compteur_Chaines_Temporaire_		DWORD ?


.CODE
ALIGN 16
;
; convertir un dword en texte au format dcimale (routine la plus stable pour le travail)
;
; syntaxe :
; mov eax,{la valeur  convertir en chane}
; mov esi,{adresse (offset) de la chaine de caractres  crer}
; call ConvertirValeurEnChaineDecimale
;
;
; Retourne :
; rien
;
ConvertirValeurEnChaineDecimale PROC
		push eax										;; empiler eax
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		mov ecx,eax									;; copier eax dans ecx
; on va diviser eax par 100000 de manire optimise
		mov edx,2814749768								;; placer 2814749768 (remplacement de 2814749767 et eax+1) dans edx
		mul edx										;; multiplier eax par 2814749768
		shr edx,16									;; dcaler edx de 16 bits  droite
		mov eax,100000									;; placer 100000 dans eax
		mov ebx,edx									;; copier edx dans ebx
		mul edx										;; multiplier edx par 100000
		sub ecx,eax									;; soustraire le rsultat en eax  ecx
		test ebx,ebx									;; fixer les flags de ebx
		mov edx,ebx									;; replacer ebx dans edx
		mov ebx,10									;; placer 10 (notre multiplicateur dcimale) dans ebx
		jz Label01									;; si c'est gal  0, aller Label01
; sinon, on traite la partie suprieure du nombre
		mov eax,429497									;; on remplace eax par 429497
		mul edx										;; multiplier edx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label10									;; s'il existe un dpassement, aller Label10
		mul ebx										;; multiplier eax par 10
		jc Label09									;; s'il existe un dpassement, aller Label09
		mul ebx										;; multiplier eax par 10
		jc Label08									;; s'il existe un dpassement, aller Label08
		mul ebx										;; multiplier eax par 10
		jc Label07									;; s'il existe un dpassement, aller Label07
		mul ebx										;; multiplier eax par 10
		jc Label06									;; s'il existe un dpassement, aller Label06
; ici, on traite la partie infrieure du nombre
Label01:	mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label05									;; s'il existe un dpassement, aller Label05
		mul ebx										;; multiplier eax par 10
		jc Label04									;; s'il existe un dpassement, aller Label04
		mul ebx										;; multiplier eax par 10
		jc Label03									;; s'il existe un dpassement, aller Label03
		mul ebx										;; multiplier eax par 10
		jc Label02									;; s'il existe un dpassement, aller Label02
		mul ebx										;; multiplier eax par 10
; ici, on va placer X et le zro final
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va placer XX et le zro final
Label02:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+1],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va placer XXX et le zro final
Label03:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+2],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va placer XXXX et le zro final
Label04:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+3],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va placer XXXXX et le zro final
Label05:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+4],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va placer XXXXXX et le zro final
Label06:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+5],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va placer XXXXXXX et le zro final
Label07:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; placer l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+5],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+6],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va placer XXXXXXXX et le zro final
Label08:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; placer l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+5],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+6],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+7],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va placer XXXXXXXXX et le zro final
Label09:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; placer l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+5],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+6],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+7],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+8],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va placer XXXXXXXXXX et le zro final
Label10:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; placer l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+5],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+6],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+7],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+8],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+9],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi

Label11:	pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
ConvertirValeurEnChaineDecimale ENDP


ALIGN 16
;
; copier une chane de caractres dans une autre chane
; note : videment, les tailles doivent tre valides pour les chanes source et destination
;
; Syntaxe :
; mov esi,{adresse (offset) de la chane source}
; mov edi,{adresse (offset) dans la chane de destination}
; syntaxe : CopierChaineAscii
;
; Retourne :
; eax = nombre de caractres copis (c-a-d la taille ajoute  la chane)
;
CopierChaineAscii PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		xor eax,eax									;; effacer eax (notre compteur d'octets)
		jmp Label2									;; aller Label2
		nop											;; ) alignement ncessaire pour un meilleur rendement
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
Label1:	add edx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de eax
		mov DWORD PTR [edi+eax],edx						;; placer cette valeur  l'adresse de destination
		add eax,4										;; incrmenter esi (l'adresse) de 4 (un dword)
Label2:	mov ecx,DWORD PTR [esi+eax]						;; placer le dword de l'adresse actuelle dans eax
		lea edx,[ecx-01010101h]							;; placer eax (- 1  chaque octets du dword) dans edx
		xor ecx,edx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans edx comme masque
		and ecx,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label1										;; si le filtrage est gal  0, aller Label1
		and ecx,edx									;; ne conserver en eax que les bits positionns en edx
		jz Label1										;; si le filtrage est gal  0, aller Label1
		add edx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de ecx
		mov [edi+eax],dl								;; placer dl  l'adresse en edi+eax
		test dl,dl									;; fixer les flags de dl
		jz Label5										;; si c'est gal  0, aller Label5
		mov [edi+eax+1],dh								;; placer dh  l'adresse en edi+eax+1
		test dh,dh									;; fixer les flags de dh
		jz Label4										;; si c'est gal  0, aller Label4
		shr edx,16									;; dcaler edx  droite de 16 bits
		mov [edi+eax+2],dl								;; placer dl  l'adresse en edi+eax+2
		test dl,dl									;; fixer les flags de dl
		jz Label3										;; si c'est gal  0, aller Label3
		mov [edi+eax+3],dh								;; placer dh  l'adresse en edi+eax+3
		inc eax										;; ajouter 1  eax ) (optionnel) pour obtenir la taille de la chaine dans eax
Label3:	inc eax										;; ajouter 1  eax )
Label4:	inc eax										;; ajouter 1  eax )
Label5:
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
CopierChaineAscii ENDP


ALIGN 16
;
; fusionner des chaines de caractres
; note : c'est plus rapide si edi pointe exactement  l'emplacement o on ajoutera la chane, mais dans ce cas l,
; eax retournera uniquement la taille de la chane ajoute
;
; Syntaxe :
; mov esi,{adresse (offset) de la chane source que l'on ajoutera}
; mov edi,{adresse (offset) de/dans la chane de destination}
; call FusionnerChainesAscii
;
; Retourne :
; eax = la taille de la chaine ou la taille de la chaine ajoute (suivant que edi contenait l'adresse de dpart ou l'adresse de fin de la chaine de destination)
;
FusionnerChainesAscii PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push edi										;; empiler edi

; premirement on va trouver le zro final de la chaine de destination
Label1:	mov eax,DWORD PTR [edi]							;; placer le dword de l'adresse actuelle dans eax
		add edi,4										;; incrmenter edi (l'adresse) de 4 (un dword)
		lea edx,[eax-01010101h]							;; placer eax (- 1  chaque octets du dword) dans edx
		xor eax,edx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans edx comme masque
		and eax,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label1										;; si le filtrage est gal  0, aller Label1
		and eax,edx									;; ne conserver en eax que les bits positionns en edx
		jz Label1										;; si le filtrage est gal  0, aller Label1
		bsf edx,eax									;; sinon, scanner le premier bit arm en eax, en commencant par la droite. et placer le numro du bit en edx
		sub edx,4										;; soustraire 4 au numro du bit obtenu
		shr edx,3										;; dcaler edx  droite de 3 bits pour obtenir le nombre d'octets
		lea edi,[edi+edx-4]								;; placer edi + edx - 1 dword dans edi
; et on effectue la copie
		xor eax,eax									;; effacer eax (notre compteur d'octets)
		jmp Label3									;; aller Label3
Label2:	add ecx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de eax
		mov DWORD PTR [edi+eax],ecx						;; placer cette valeur  l'adresse de destination
		add eax,4										;; incrmenter esi (l'adresse) de 4 (un dword)
;		nop											;; ) aucun alignement ncessaire pour un meilleur rendement
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
Label3:	mov edx,DWORD PTR [esi+eax]						;; placer le dword de l'adresse actuelle dans eax
		lea ecx,[edx-01010101h]							;; placer eax (- 1  chaque octets du dword) dans ecx
		xor edx,ecx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans ecx comme masque
		and edx,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label2										;; si le filtrage est gal  0, aller Label2
		and edx,ecx									;; ne conserver en eax que les bits positionns en ecx
		jz Label2										;; si le filtrage est gal  0, aller Label2
		add ecx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de edx
		mov [edi+eax],cl								;; placer cl  l'adresse en edi+eax
		test cl,cl									;; fixer les flags de cl
		jz Label6										;; si c'est gal  0, aller Label5
		mov [edi+eax+1],ch								;; placer ch  l'adresse en edi+eax+1
		test ch,ch									;; fixer les flags de ch
		jz Label5										;; si c'est gal  0, aller Label4
		shr ecx,16									;; dcaler ecx  droite de 16 bits
		mov [edi+eax+2],cl								;; placer cl  l'adresse en edi+eax+2
		test cl,cl									;; fixer les flags de cl
		jz Label4										;; si c'est gal  0, aller Label3
		mov [edi+eax+3],ch								;; placer ch  l'adresse en edi+eax+3
		inc eax										;; ajouter 1  eax ) (optionnel) pour obtenir la taille de la chaine dans eax
Label4:	inc eax										;; ajouter 1  eax )
Label5:	inc eax										;; ajouter 1  eax )
Label6:	add eax,edi									;; ajouter edi  eax

		pop edi										;; dsempiler edi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		sub eax,edi									;; et on soustrait l'adresse originelle  eax pour obtenir la nouvelle taille de la chane
	ret												;; retourner (sortir de la procdure)
FusionnerChainesAscii ENDP


ALIGN 16
;
; obtenir la taille relle d'une chane de caractres
;
; Syntaxe :
; mov esi,{adresse (offset) de la chane dont on veut obtenir la taille}
; call ObtenirTailleChaineAscii
;
; Retourne :
; eax = taille relle de la chane
;
ObtenirTailleChaineAscii PROC
		push ebx										;; empiler ebx
		push edx										;; empiler edx

		xor eax,eax									;; effacer eax (qui sera notre compteur)
;		nop											;; ) aucun alignement ncessaire pour un meilleur rendement
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
Label1:	mov ebx,DWORD PTR [esi+eax]						;; placer le dword de l'adresse actuelle dans ebx
		add eax,DWORD									;; incrmenter eax (le compteur) de 4 (un dword)
		lea edx,[ebx-01010101h]							;; placer ebx (- 1  chaque octets) dans edx
		xor ebx,edx									;; inverser les bits en ebx, en utilisant le rsultat obtenu dans edx comme masque
		and ebx,80808080h								;; ne conserver que le bit de poids fort de chaques octets en ebx
		jz Label1										;; si le filtrage est gal  0, aller Label1
		and ebx,edx									;; ne conserver en ebx que les bits positionns en edx
		jz Label1										;; si le filtrage est gal  0, aller Label1
		bsf edx,ebx									;; sinon, scanner le premier bit arm en ebx, en commencant par la droite. et placer le numro du bit en edx
		sub edx,4										;; soustraire 4 au numro du bit obtenu
		shr edx,3										;; dcaler edx  droite de 3 bits pour obtenir le nombre d'octets
		lea eax,[eax+edx-DWORD]							;; placer eax + edx - 1 dword dans eax

		pop edx										;; dsempiler edx
		pop ebx										;; dsempiler ebx
	ret												;; retourner (sortir de la procdure)
ObtenirTailleChaineAscii ENDP


